 #include "ads.h"
 #include "LPC17xx.h"
 #include "TFTLCD.h"
 int POINT_COLOR = RED;
 Pen_Holder Pen_Point;
/*
*********************************************************************************************************
* Description: 	Dealy function of us.
* Arguments  : 	nus : the data of us
* Returns    : 	None
*********************************************************************************************************
*/
/*
void delay_us(int nus)
{
	//while(nus--);
}

*/
/*
*********************************************************************************************************
* Description: 	Write data.
* Arguments  : 	num : the data value
* Returns    : 	None
*********************************************************************************************************
*/	   
void ADS_Write_Byte(char num)    
{  
	char count=0;
	
	for(count=0;count<8;count++)  
	{ 	  
		if(num&0x80)
		{
			TDIN(1);
		}  
		else 
		{
			TDIN(0);
		}   
		num<<=1;    
		TCLK(0);
		delay_us(1);	   	 
		TCLK(1);	
	} 			    
} 

/*
*********************************************************************************************************
* Description: 	Reading the value of ADC from 7846/7843/XPT2046/UH7843/UH7846.
* Arguments  : 	CMD  the Command value
* Returns    : 	None
*********************************************************************************************************
*/		   
int ADS_Read_AD(char CMD)	  
{ 	 
	char count=0; 	  
	int Num=0;
 
	TCLK(0);	 
	TCS(0); 
	TCLK(0);
	delay_us(10);		 
	ADS_Write_Byte(CMD);
	delay_us(13);		   	    
	TCLK(0);
	delay_us(1);		 
	for(count=0;count<16;count++)  
	{ 				  
		Num<<=1; 	 
		TCLK(0);
		delay_us(1);  	    	   
		TCLK(1);
		if(DOUT)
			Num++; 		 
	}	 	
	Num>>=4;
	TCS(1);	 
	return(Num);   
}
/*
*********************************************************************************************************
* Description: 	Take an order for the value value.
* Arguments  : 	xy  the Command value
* Returns    : 	None
*********************************************************************************************************
*/	 
#define READ_TIMES 15 
#define LOST_VAL 5	 
int ADS_Read_XY(char xy)
{
	int i, j;
	int buf[READ_TIMES];
	int sum=0;
	int temp;
	for(i=0;i<READ_TIMES;i++)
	{				 
		buf[i]=ADS_Read_AD(xy);	    
	}				    
	for(i=0;i<READ_TIMES-1; i++)
	{
		for(j=i+1;j<READ_TIMES;j++)
		{
			if(buf[i]>buf[j])
			{
				temp=buf[i];
				buf[i]=buf[j];
				buf[j]=temp;
			}
		}
	}	  
	sum=0;
	for(i=LOST_VAL;i<READ_TIMES-LOST_VAL;i++)sum+=buf[i];
	temp=sum/(READ_TIMES-2*LOST_VAL);
	return temp;   
} 
/*
*********************************************************************************************************
* Description: 	Getting the real value of AD function.
* Arguments  : 	*x ,*y   the cale of AD value
* Returns    : 	None
*********************************************************************************************************
*/	
char Read_ADS(int *x,int *y)
{
	int xtemp,ytemp;			 	 		  
	xtemp=ADS_Read_XY(CMD_RDX);
	ytemp=ADS_Read_XY(CMD_RDY);	  												   
	if(xtemp<100||ytemp<100)return 0;							//fail
	*x=xtemp;
	*y=ytemp;
	return 1;													//success
}

#define ERR_RANGE 50 				
char Read_ADS2(int *x,int *y) 
{
	int x1,y1;
 	int x2,y2;
 	char flag;    
    flag=Read_ADS(&x1,&y1);   
    if(flag==0)return(0);
    flag=Read_ADS(&x2,&y2);	   
    if(flag==0)return(0);   
    if(((x2<=x1&&x1<x2+ERR_RANGE)||(x1<=x2&&x2<x1+ERR_RANGE))
    &&((y2<=y1&&y1<y2+ERR_RANGE)||(y1<=y2&&y2<y1+ERR_RANGE)))
    {
        *x=(x1+x2)/2;
        *y=(y1+y2)/2;
        return 1;
    }else return 0;	  
} 

/*
*********************************************************************************************************
* Description: 	Getting the touch value of coordinate function.
* Arguments  :  None
* Returns    : 	None
*********************************************************************************************************
*/				   
char Read_TP_Once(void)
{
	char t=0;	    
	//Pen_Int_Set(0);
	//Pen_Point.Key_Sta=Key_Up;
	//Read_ADS2(&Pen_Point.X,&Pen_Point.Y);
	while(Read_ADS2(&Pen_Point.X,&Pen_Point.Y)==0) ;
	
	//Pen_Int_Set(1);		 
	return 1;	
}

/*
*********************************************************************************************************
* Description: 	Draw a touch point function.
* Arguments  : 	x ,y  the coordinate value
* Returns    : 	None
*********************************************************************************************************
*/
void Drow_Touch_Point(int x,int y)
{
	tftlcd_draw_line(x-12,y,x+13,y,POINT_COLOR);
	tftlcd_draw_line(x,y-12,x,y+13,POINT_COLOR);
	tftlcd_write_pixel(x+1,y+1,POINT_COLOR);
	tftlcd_write_pixel(x-1,y+1,POINT_COLOR);
	tftlcd_write_pixel(x+1,y-1,POINT_COLOR);
	tftlcd_write_pixel(x-1,y-1,POINT_COLOR);
	tftlcd_draw_circle(x,y,6,0,POINT_COLOR);
}


/*
*********************************************************************************************************
* Description: 	Draw a big point function.
* Arguments  : 	x ,y  the coordinate value
* Returns    : 	None
*********************************************************************************************************
*/			   
void Draw_Big_Point(int x,int y)
{	    
	tftlcd_write_pixel(x,y,POINT_COLOR);
	tftlcd_write_pixel(x+1,y,POINT_COLOR);
	tftlcd_write_pixel(x,y+1,POINT_COLOR);
	tftlcd_write_pixel(x+1,y+1,POINT_COLOR);	 	  	
}


/*
*********************************************************************************************************
* Description: 	Getting the value of coordinate function.
* Arguments  : 	None
* Returns    : 	None
*********************************************************************************************************
*/
char Convert_Pos(void)
{		 	  
	if(Read_ADS2(&Pen_Point.X,&Pen_Point.Y))
	{
		Pen_Point.X0=Pen_Point.xfac*Pen_Point.X+Pen_Point.xoff;
		Pen_Point.Y0=Pen_Point.yfac*Pen_Point.Y+Pen_Point.yoff; 
		return 1; 
 
	}
	return 0;
}


/*
*********************************************************************************************************
* Description: 	Touch screen adjust function.Getting four adjust parameter!
* Arguments  : 	None
* Returns    : 	None
*********************************************************************************************************
*/
void Touch_Adjust(void)
{								 
	int pos_temp[4][2];									//Coordinate cache value
	char  cnt=0;	
	int d1,d2;
	int x,y;
	long tem1,tem2;
	float fac; 	   
	cnt=0;				
	
	
	tftlcd_clear();   
	Drow_Touch_Point(20,20);						   //Draw the first point 
	Pen_Point.Key_Sta=Key_Up;						   //Clear the signal 
	Pen_Point.xfac=0;								   //Record whether adjust 
	while(1)
	{
		if(Read_ADS(&x,&y)!=0)				   //Is touched
		{
			if(Read_TP_Once())						   //got the coordinate value
			{  								   
				pos_temp[cnt][0]=Pen_Point.X;
				pos_temp[cnt][1]=Pen_Point.Y;
				cnt++;
			}
			while(Read_ADS(&x,&y)!=0);				 
			switch(cnt)
			{			   
				case 1:
					tftlcd_clear(); 
					Drow_Touch_Point(220,20);			//Draw the second point
					break;
				case 2:
					tftlcd_clear();
					Drow_Touch_Point(20,300);			//Draw the third point
					break;
				case 3:
					tftlcd_clear();
					Drow_Touch_Point(220,300);			//Draw the fouth point
					break;
				case 4:	 								//Have gotten all the value
	    		    /*????*/
					tem1=abs(pos_temp[0][0]-pos_temp[1][0]);//x1-x2
					tem2=abs(pos_temp[0][1]-pos_temp[1][1]);//y1-y2
					tem1*=tem1;
					tem2*=tem2;
					d1=sqrt(tem1+tem2);
					
					tem1=abs(pos_temp[2][0]-pos_temp[3][0]);//x3-x4
					tem2=abs(pos_temp[2][1]-pos_temp[3][1]);//y3-y4
					tem1*=tem1;
					tem2*=tem2;
					d2=sqrt(tem1+tem2);
					fac=(float)d1/d2;
					//if(fac<0.95||fac>1.05||d1==0||d2==0)	//Unqualified
					//{
						//cnt=0;
						//tftlcd_clear(); 
						//Drow_Touch_Point(20,20);
					//	continue;
					//}
					tem1=abs(pos_temp[0][0]-pos_temp[2][0]);//x1-x3
					tem2=abs(pos_temp[0][1]-pos_temp[2][1]);//y1-y3
					tem1*=tem1;
					tem2*=tem2;
					d1=sqrt(tem1+tem2);
					
					tem1=abs(pos_temp[1][0]-pos_temp[3][0]);//x2-x4
					tem2=abs(pos_temp[1][1]-pos_temp[3][1]);//y2-y4
					tem1*=tem1;
					tem2*=tem2;
					d2=sqrt(tem1+tem2);
					fac=(float)d1/d2;
					/*
					if(fac<0.95||fac>1.05)					//Unqualified
					{
						cnt=0;
						tftlcd_clear();
						Drow_Touch_Point(20,20);
						continue;
					}
					*/			   
					/*??????*/
					tem1=abs(pos_temp[1][0]-pos_temp[2][0]);//x1-x3
					tem2=abs(pos_temp[1][1]-pos_temp[2][1]);//y1-y3
					tem1*=tem1;
					tem2*=tem2;
					d1=sqrt(tem1+tem2);
	
					tem1=abs(pos_temp[0][0]-pos_temp[3][0]);//x2-x4
					tem2=abs(pos_temp[0][1]-pos_temp[3][1]);//y2-y4
					tem1*=tem1;
					tem2*=tem2;
					d2=sqrt(tem1+tem2);
					fac=(float)d1/d2;
					/*
					if(fac<0.95||fac>1.05)													//Unqualified
					{
						cnt=0;
						tftlcd_clear();
						Drow_Touch_Point(20,20);
						continue;
					} */
					/*?????,???? */
					Pen_Point.xfac=(float)200/(pos_temp[1][0]-pos_temp[0][0]);				// got xfac		 
					Pen_Point.xoff=(240-Pen_Point.xfac*(pos_temp[1][0]+pos_temp[0][0]))/2;	//got xoff
						  
					Pen_Point.yfac=(float)280/(pos_temp[2][1]-pos_temp[0][1]);				//got yfac
					Pen_Point.yoff=(320-Pen_Point.yfac*(pos_temp[2][1]+pos_temp[0][1]))/2;	//got yoff  
					//POINT_COLOR=Blue;
					//LCD_Clear(White);
					//LCD_ShowString(35,110,"Touch Screen Adjust OK!");					    //Adjust is OK
					//delay_ms(1000);
					tftlcd_clear();   
					return;
				 
			}
		}
	} 
}		

/*
*********************************************************************************************************
* Description: 	Touch screen adjust function.Getting four adjust parameter!
* Arguments  : 	None
* Returns    : 	None
*********************************************************************************************************
*/
	


void Touch_Init(void)
{			    		   
	LPC_GPIO0->FIODIR |= (1<<7)|(1<<9)|(1<<19) ;  		//P0.6 0.7 0.9 Output
	

}

